//----------------------------------------------------------
//   enums_pas.frm
//   TextTransformer Support Frame
//   Copyright: Dr. Detlef Meyer-Eltz 
//   http://www.texttransformer.de
//   http://www.texttransformer.com
//   dme@texttransformer.com
//
//   November, 2008  Version 1.6.0
//----------------------------------------------------------

unit Inienums;

interface

Type

  EToken = (
  // token enumeration (don't delete this marker)
  tkEORIni, // end of recognition
  tkEOF, // EOF
  tkEPS, // EPS
  tkANY, // ANY
  tkEXIT_OK, // EXIT_OK
  tkEXIT_ERR, // EXIT_ERR
  tkBREAK, // BREAK
  tkLbrack, // "["
  tkID, // ID
  tkRbrack, // "]"
  tkSemicolon, // ";"
  tkROL, // ROL
  tkEqual, // "="
  tkLastIni
  );

  EProduction = (
  // production enumeration (don't delete this marker)
  pdNullIni, // index correction
  pdIni, // Ini
  pdSection, // Section
  pdComment, // Comment
  pdEntry, // Entry
  pdValue, // Value
  pdLastIni
  ); 


const
  aTokens: array[EToken] of string = (
  '', // index correction
  'EOF',
  'EPS',
  'ANY',
  'EXIT_OK',
  'EXIT_ERR',
  'BREAK',
  '"["',
  'ID',
  '"]"',
  '";"',
  'ROL',
  '"="',
  ''
  );

  aProductions: array[EProduction] of string = (
  '', // index correction
  'Ini',
  'Section',
  'Comment',
  'Entry',
  'Value',
  ''
  );


implementation

end.