//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CustomTransformer"
#pragma resource "*.dfm"
TForm2 *Form2;

// Place a TEdit inside a TListBox to enable inplace editing of ListBox items
// http://delphi.about.com/od/adptips2005/qt/listboxedit.htm
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormCreate(TObject *Sender)
{
   Edit1 = new TEdit(this) ;
   Edit1->Visible = false;
   Edit1->Ctl3D = false;
   Edit1->BorderStyle = bsNone;
   Edit1->Parent = lb_TargetFiles;
   Edit1->Width = lb_TargetFiles->ClientWidth;
   Edit1->OnKeyPress = Edit1KeyPress;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Edit1KeyPress(TObject *Sender, char &Key)
{
  int iIndex;

  if( Key == 13 )
  {
    iIndex = lb_TargetFiles->ItemIndex;
    if( iIndex == -1 )
      return;
    lb_TargetFiles->Selected[iIndex] = false; // moved
    lb_TargetFiles->Items->Delete(iIndex) ;
    lb_TargetFiles->Items->Insert(iIndex, Edit1->Text) ;
    Edit1->Visible = false;
    Key = 0;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm2::lb_TargetFilesClick(TObject *Sender)
{
  int iIndex;;
  TRect lRect;

  iIndex = lb_TargetFiles->ItemIndex;
  if( iIndex == -1 )
    return;

  lRect = lb_TargetFiles->ItemRect(iIndex) ;
  Edit1->Top = lRect.Top + 1;
  Edit1->Left = lRect.Left + 1;
  Edit1->Height = (lRect.Bottom - lRect.Top) + 1;

  Edit1->Text = lb_TargetFiles->Items->Strings[iIndex];
  // moved lb_TargetFiles->Selected[iIndex] = false;
  Edit1->Visible = true;
  Edit1->SelectAll();
  Edit1->SetFocus();
}

//---------------------------------------------------------------------------
void __fastcall TForm2::FormResize(TObject *Sender)
{
  lb_TargetFiles->Align = alNone;
  lb_SourceFiles->Width = Form2->Width / 2;
  lb_TargetFiles->Align = alClient;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button1Click(TObject *Sender)
{
  OpenDialog1->DefaultExt = "TXT";
  OpenDialog1->FileName = "*.txt";
  if(OpenDialog1->Execute())
  {
    lb_SourceFiles->Items->Add(OpenDialog1->FileName);
    lb_TargetFiles->Items->Add(ChangeFileExt(OpenDialog1->FileName, ".html"));
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button2Click(TObject *Sender)
{
  lb_SourceFiles->Clear();
  lb_TargetFiles->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button3Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button4Click(TObject *Sender)
{
  lb_SourceFiles->ItemIndex = 0;
  TextFileN2NTransformer1->SourceFiles->Assign(lb_SourceFiles->Items);
  TextFileN2NTransformer1->TargetFiles->Assign(lb_TargetFiles->Items);
  if(TextFileN2NTransformer1->Execute())
     Application->MessageBox("files successfully transformed", "Error");
   else
     Application->MessageBox("could not transform at least one file", "Error");
}
//---------------------------------------------------------------------------
void __fastcall TForm2::TextFileN2NTransformer1Exception(TObject *Sender,
      AnsiString xasWhat)
{
  Application->MessageBox(xasWhat.c_str(), "Exception");
  TextFileN2NTransformer1->Stop();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::TextFileN2NTransformer1ParserMessage(TObject *Sender,
      AnsiString xasWhat, DWORD xlwLastPosition, DWORD xlwPosition,
      const AnsiString xasProduction, const AnsiString xasSymbol,
      eParserMessage xeMessageType, DWORD xlw)
{
  Application->MessageBox(xasWhat.c_str(), "ParserMessage");
  TextFileN2NTransformer1->Stop();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::TextFileN2NTransformer1FileError(TObject *Sender,
      const AnsiString xasSourceFile, const AnsiString xasTargetFile,
      const AnsiString xasMessage)
{
  AnsiString sMessage = "could not transform file: ";
  sMessage += xasSourceFile;
  sMessage += " to ";
  sMessage += xasTargetFile;
  Application->MessageBox(sMessage.c_str(), "FileError");
  TextFileN2NTransformer1->Stop();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::TextFileN2NTransformer1FileSuccess(TObject *Sender,
      const AnsiString xasSourceFile, const AnsiString xasTargetFile,
      const AnsiString xasMessage)
{
  lb_SourceFiles->ItemIndex++;
}

//---------------------------------------------------------------------------

void __fastcall TForm2::lb_TargetFilesExit(TObject *Sender)
{
  Edit1->Visible = false;
}
//---------------------------------------------------------------------------

