unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Menus, OleCtrls, SHDocVw, ActiveX, StdCtrls,
  StringTransformer, Unit2, Unit3, ToolWin, TetraTree, CustomTransformer, TetraTypes,
  ExtCtrls, MemoTransformer;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    ts_Edit: TTabSheet;
    ts_View: TTabSheet;
    ts_Html: TTabSheet;
    MainMenu1: TMainMenu;
    Menu: TMenuItem;
    N1: TMenuItem;
    mi_OpenProject: TMenuItem;
    mi_SaveTarget: TMenuItem;
    N3: TMenuItem;
    FiletransformerNN1: TMenuItem;
    FiletransformerN11: TMenuItem;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    mi_OpenFile: TMenuItem;
    StatusBar1: TStatusBar;
    Memo2: TMemo;
    WebBrowser1: TWebBrowser;
    N4: TMenuItem;
    mi_Close: TMenuItem;
    ts_Tree: TTabSheet;
    TreeView1: TTreeView;
    PopupMenu1: TPopupMenu;
    pmi_Expand: TMenuItem;
    pmi_Collapse: TMenuItem;
    TextTreeViewTransformer1: TTextTreeViewTransformer;
    Panel1: TPanel;
    ComboBox1: TComboBox;
    edt_Token: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog2: TOpenDialog;
    MemoTextTransformer1: TMemoTextTransformer;
    procedure MemoTextTransformer1ParserMessage(Sender: TObject; xasWhat: string;
      xlwLastPosition, xlwPosition: Cardinal; const xasProduction,
      xasSymbol: string; xeMessageType: eParserMessage; xlw: Cardinal);
    procedure WebBrowser1BeforeNavigate2(ASender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure FiletransformerN11Click(Sender: TObject);
    procedure FiletransformerNN1Click(Sender: TObject);
    procedure mi_CloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mi_OpenFileClick(Sender: TObject);
    procedure mi_SaveTargetClick(Sender: TObject);
    procedure mi_OpenProjectClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pmi_ExpandClick(Sender: TObject);
    procedure pmi_CollapseClick(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MemoTextTransformer1Exception(Sender: TObject; xasWhat: string);
  private
    { Private-Deklarationen }
    m_bAllowNavigate : BOOLEAN;

    procedure SetProject(xasProject : AnsiString);
    function Execute(xTransformer : TCustomTextTransformer) : BOOLEAN;
    procedure OpenFile(xFilename: AnsiString);

  public
    { Public-Deklarationen }
    //constructor TForm1(Owner : TComponent);
  end;

var
  Form1: TForm1;

implementation

uses Unit4;

{$R *.dfm}

procedure WB_LoadHTML(WebBrowser: TWebBrowser; HTMLCode: string);
var  
  sl: TStringList;  
  ms: TMemoryStream;  
begin  
  WebBrowser.Navigate('about:blank');  
  while WebBrowser.ReadyState < READYSTATE_INTERACTIVE do
   Application.ProcessMessages;  

 
  if Assigned(WebBrowser.Document) then
  begin  
    sl := TStringList.Create;
    try
      ms := TMemoryStream.Create;
      try
        sl.Text := HTMLCode;
        sl.SaveToStream(ms);
        ms.Seek(0, 0);  
       (WebBrowser.Document as IPersistStreamInit).Load(TStreamAdapter.Create(ms));
      finally
        ms.Free;
      end;
    finally
      sl.Free;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  m_bAllowNavigate := true;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  inistr : TStringList;
begin
  inistr := TStringList.Create();
  try
    if FileExists(ChangeFileExt(Application.ExeName, '.ini')) then
    begin
      inistr.LoadFromFile(ChangeFileExt(Application.ExeName, '.ini'));
      DataModule4.Parse(inistr.Text);
    end;
  finally
    inistr.Free();
  end;
  SetProject(DataModule4.Project);
  OpenFile(DataModule4.InputFile);
  Top := DataModule4.Top;
  Left := DataModule4.Left;
  Height := DataModule4.Height;
  Width := DataModule4.Width;

  ComboBox1.ItemIndex := INTEGER(TextTreeViewTransformer1.TreeType);
  MemoTextTransformer1.Input := Memo1;
  TextTreeViewTransformer1.Input := Memo1;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if WindowState = wsNormal then
  begin
    DataModule4.Top := Top;
    DataModule4.Left := Left;
    DataModule4.Height := Height;
    DataModule4.Width := Width;
  end;
  DataModule4.WriteIni();
  MemoTextTransformer1.FreeLibrary(); // in CBuilder 2006 not necessary, but in CBuilder 6 to avoid a crash
  ComboBox1.OnChange := NIL;
end;

procedure TForm1.mi_CloseClick(Sender: TObject);
begin
  Close();
end;

procedure TForm1.SetProject(xasProject : AnsiString);
begin
  TextTreeViewTransformer1.Project := xasProject;
  //TextTreeViewTransformer1.Tokens := Text2Htmlenums.Tokens;
  //TextTreeViewTransformer1.Productions := Text2Htmlenums.Productions;
  MemoTextTransformer1.Project := xasProject;
  Form2.TextFileN2NTransformer1.Project := xasProject;
  Form3.TextFileN21Transformer1.Project := xasProject;
  StatusBar1.SimpleText := xasProject;
  PageControl1.ActivePage := ts_Edit;
  DataModule4.Project := xasProject;
end;

procedure TForm1.mi_OpenFileClick(Sender: TObject);
begin
  OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName);
  if OpenDialog1.Execute() then
	  OpenFile(OpenDialog1.FileName);
end;

procedure TForm1.OpenFile(xFilename: AnsiString);
begin
  MemoTextTransformer1.Input.Lines.LoadFromFile(xFilename);
  PageControl1.ActivePage := ts_Edit;
  DataModule4.InputFile := xFilename;
end;

procedure TForm1.mi_SaveTargetClick(Sender: TObject);
begin
  if SaveDialog1.Execute() then
  begin
     Memo2.Lines.SaveToFile(SaveDialog1.FileName);
  end;
end;

procedure TForm1.mi_OpenProjectClick(Sender: TObject);
var
  Cursor : TCursor;
begin
  Cursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  OpenDialog2.InitialDir := ExtractFilePath(Application.ExeName);

  if OpenDialog2.Execute() then
    SetProject(OpenDialog2.FileName);

  Screen.Cursor := Cursor;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
var
  Cursor : TCursor;
begin

  Cursor  := Screen.Cursor;
  Screen.Cursor := crHourGlass;

  if  (PageControl1.ActivePage = ts_View) or
      (PageControl1.ActivePage = ts_HTML) then
  begin

    Execute(MemoTextTransformer1);

    m_bAllowNavigate := true;
    WB_LoadHTML(WebBrowser1, Memo2.Text);
    m_bAllowNavigate := false;

  end
  else
  if PageControl1.ActivePage = ts_Tree then
    Execute(TextTreeViewTransformer1);

  Screen.Cursor := Cursor;

end;

function TForm1.Execute(xTransformer : TCustomTextTransformer) : BOOLEAN;
begin
  if not xTransformer.SetActive() then begin
    ShowMessage(xTransformer.Project + ' cannot be activated!');
    Screen.Cursor := Cursor;
    Result := false;
    EXIT
  end;

  if xTransformer.Modified then
     Result := xTransformer.Execute()
    else
     Result := true;

end;

procedure TForm1.pmi_CollapseClick(Sender: TObject);
begin
  if TreeView1.Selected <> NIL then
  begin
    TreeView1.Selected.Collapse(true);
    TreeView1.TopItem := TreeView1.Selected;
  end;
end;

procedure TForm1.pmi_ExpandClick(Sender: TObject);
begin
  if TreeView1.Selected <> NIL then
  begin
    TreeView1.Selected.Expand(true);
    TreeView1.TopItem := TreeView1.Selected;
  end;
end;

procedure TForm1.TreeView1Click(Sender: TObject);
var
  n: TTetraNode;
begin
  n := TreeView1.Selected as TTetraNode;
  if n <> nil then
    edt_Token.Text := n.RecognizedText();
end;

procedure TForm1.MemoTextTransformer1Exception(Sender: TObject;
  xasWhat: string);
begin
  Application.MessageBox(PChar(xasWhat), 'Exception');
end;

procedure TForm1.MemoTextTransformer1ParserMessage(Sender: TObject; xasWhat: string;
  xlwLastPosition, xlwPosition: Cardinal; const xasProduction,
  xasSymbol: string; xeMessageType: eParserMessage; xlw: Cardinal);
begin
  Application.MessageBox(PChar(xasWhat), 'ParserMessage');
  PageControl1.ActivePage := ts_Edit;
  Memo1.SetFocus();
  Memo1.SelStart := xlwLastPosition;
  Memo1.SelLength := xlwPosition - xlwLastPosition;

end;

procedure TForm1.WebBrowser1BeforeNavigate2(ASender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
begin
  Cancel := not m_bAllowNavigate;
end;

procedure TForm1.FiletransformerNN1Click(Sender: TObject);
begin
  if not Form2.TextFileN2NTransformer1.SetActive() then begin
    ShowMessage(Form2.TextFileN2NTransformer1.Project + ' cannot be activated!');
    Screen.Cursor := Cursor;
    EXIT
  end;
  Form2.ShowModal();
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  if TextTreeViewTransformer1.TreeType <> eTreeType(ComboBox1.ItemIndex) then begin
  TextTreeViewTransformer1.TreeType := eTreeType(ComboBox1.ItemIndex);
  Execute(TextTreeViewTransformer1);
  end;
end;

procedure TForm1.FiletransformerN11Click(Sender: TObject);
begin
  if not Form3.TextFileN21Transformer1.SetActive() then begin
    ShowMessage(Form3.TextFileN21Transformer1.Project + ' cannot be activated!');
    Screen.Cursor := Cursor;
    EXIT
  end;
  Form3.ShowModal();
end;


end.

