unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FileTransformer, StdCtrls, ExtCtrls, ComCtrls, ToolWin, TetraTypes,
  CustomTransformer;

type
  TForm2 = class(TForm)
    ToolBar1: TToolBar;
    StatusBar1: TStatusBar;
    lb_SourceFiles: TListBox;
    Splitter1: TSplitter;
    lb_TargetFiles: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    TextFileN2NTransformer1: TTextFileN2NTransformer;
    OpenDialog1: TOpenDialog;
    procedure TextFileN2NTransformer1ParserMessage(Sender: TObject; xasWhat: string;
      xlwLastPosition, xlwPosition: Cardinal; const xasProduction,
      xasSymbol: string; xeMessageType: eParserMessage; xlw: Cardinal);
    procedure TextFileN2NTransformer1FileSuccess(Sender: TObject; const xpSourceFile,
      xpTargetFile, xpMessage: string);
    procedure TextFileN2NTransformer1FileError(Sender: TObject; const xpSourceFile,
      xpTargetFile, xpMessage: string);
    procedure TextFileN2NTransformer1Exception(Sender: TObject; xasWhat: string);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.Button1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName);
  if OpenDialog1.Execute() then
  begin
    lb_SourceFiles.Items.Add(OpenDialog1.FileName);
    lb_TargetFiles.Items.Add(ChangeFileExt(OpenDialog1.FileName, '.html'));
  end

end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  lb_SourceFiles.ItemIndex := 0;
  TextFileN2NTransformer1.SourceFiles.Assign(lb_SourceFiles.Items);
  TextFileN2NTransformer1.TargetFiles.Assign(lb_TargetFiles.Items);
  if  TextFileN2NTransformer1.Execute() then
    Application.MessageBox('files successfully transformed', 'Error')
   else
    Application.MessageBox('could not transform at least one file', 'Error');

end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  lb_SourceFiles.Clear();
  lb_TargetFiles.Clear();
end;

procedure TForm2.Button4Click(Sender: TObject);
begin
  Close();
end;

procedure TForm2.FormResize(Sender: TObject);
begin
  lb_TargetFiles.Align := alNone;
  lb_SourceFiles.Width := Form2.Width div 2;
  lb_TargetFiles.Align := alClient;

end;

procedure TForm2.TextFileN2NTransformer1Exception(Sender: TObject; xasWhat: string);
begin
  Application.MessageBox(PChar(xasWhat), 'Exception');
  TextFileN2NTransformer1.Stop();

end;

procedure TForm2.TextFileN2NTransformer1FileError(Sender: TObject; const xpSourceFile,
  xpTargetFile, xpMessage: string);
var
  sMessage : AnsiString;
begin
  sMessage := 'could not transform file: ';
  sMessage := sMessage + xpSourceFile;
  sMessage := sMessage + ' to ';
  sMessage := sMessage + xpTargetFile;
  sMessage := sMessage +' by the Text2Html project';
  Application.MessageBox(PChar(sMessage), 'FileError');
  TextFileN2NTransformer1.Stop();

end;

procedure TForm2.TextFileN2NTransformer1FileSuccess(Sender: TObject; const xpSourceFile,
  xpTargetFile, xpMessage: string);
begin
  lb_SourceFiles.ItemIndex := lb_SourceFiles.ItemIndex + 1;
end;
procedure TForm2.TextFileN2NTransformer1ParserMessage(Sender: TObject; xasWhat: string;
  xlwLastPosition, xlwPosition: Cardinal; const xasProduction,
  xasSymbol: string; xeMessageType: eParserMessage; xlw: Cardinal);
begin
  Application.MessageBox(PChar(xasWhat), 'ParserMessage');
  TextFileN2NTransformer1.Stop();
end;

end.
