unit StringTransformer;
//----------------------------------------------------------
//   TetraComponents
//   TextTransformer Support
//   Author: Dr. Detlef Meyer-Eltz
//   Many thanks to Dr. Hans-Peter Diettrich for his PASCAL advices
//   http://www.texttransformer.de
//   http://www.texttransformer.com
//   Meyer-Eltz@t-online.de
//
//   March, 2008
//----------------------------------------------------------

interface

uses
  Classes, SysUtils, ComCtrls, StdCtrls, TetraDll, CustomTransformer, TetraMessage, TetraTypes;

type

TStringTransformer = class (TCustomTextTransformer)
public
  function TransformString(const Source: AnsiString; const ExtraParam: AnsiString = ''): AnsiString;
  function TransformToTree(const Source: AnsiString; const ExtraParam: AnsiString = ''): BOOLEAN;

published


  property EnableActions : BOOLEAN read m_bEnableActions write m_bEnableActions;
  property OnEnterProduction : TOnEnterProduction read FOnEnterProduction  write FOnEnterProduction;
  property OnExitProduction : TOnExit read FOnExitProduction  write FOnExitProduction;
  property OnAcceptToken : TOnAcceptToken read FOnAcceptToken  write FOnAcceptToken;
  property OnBeginBranch : TOnBranch read FOnBeginBranch  write FOnBeginBranch;
  property OnEndBranch : TOnExit read FOnEndBranch  write FOnEndBranch;
end;

implementation

function TStringTransformer.TransformString(const Source: AnsiString; const ExtraParam: AnsiString = ''): AnsiString;
begin
  Result := inherited TransformString(Source, ExtraParam);
end;

function TStringTransformer.TransformToTree(const Source: AnsiString; const ExtraParam: AnsiString = ''): BOOLEAN;
begin
  Result := inherited TransformToTree(Source, ExtraParam);
end;

end.
