unit TetraTypes;
//----------------------------------------------------------
//   TetraComponents
//   TextTransformer Support
//   Author: Dr. Detlef Meyer-Eltz
//   Many thanks to Dr. Hans-Peter Diettrich for his PASCAL advices
//   http://www.texttransformer.de
//   http://www.texttransformer.com
//   Meyer-Eltz@t-online.de
//
//   March, 2008
//----------------------------------------------------------

interface

uses
  SysUtils;
   
type
  TTetraProjectName = TFileName;
  TTetraEnumFileName = TFileName;

  eParserMessage = (
    pmMessage,   // = 0;
    pmExit,      // = 1;
    pmExit_Ok,   // = 2;
    pmWarning,   // = 3;
    pmError,     // = 4;
    pmParseError, // = 5;
    pmSemError,  // = 6;
    pmSuccess    // = 7;
  );

  eTetraNodeKind = (
    tnkProduction,  // production node
    tnkToken,       // token node
    tnkSkip,        // skip token node
    tnkOpt,         // optional
    tnkOptRep,      // optional repetition
    tnkRep,         // optional repetition
    tnkCount,       // counted repetition
    tnkWhile,       // conditional repetition
    tnkUnknown      // for Delphi, not returned from the engine
  );
  
  eTetraMessageKind = (
    tmkMessage,
    tmkError,
    tmkFileMessage,
    tmkParserMessage
  );

  PTetraNode = ^RTetraNode;
  RTetraNode = record
    Name : AnsiString;
    Symno : INTEGER;
    Kind: eTetraNodeKind;
    //SourceText: AnsiString;
    IgnoredBegin,
    RecognizedBegin,
    RecognizedEnd : Cardinal;
    FirstChild : PTetraNode;
    NextSibling : PTetraNode;
  end;


implementation

end.
 